"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Hello = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const react_native_1 = require("react-native");
class Hello extends react_1.default.Component {
    constructor(props) {
        super(props);
        this.onIncrement = () => this.setState({ intelligenceLevel: this.state.intelligenceLevel + 1 });
        this.onDecrement = () => this.setState({ intelligenceLevel: this.state.intelligenceLevel - 1 });
        this.getExclamationMarks = (numChars) => Array(numChars + 1).join("!");
        this.state = {
            intelligenceLevel: props.intelligenceLevel || 1,
        };
    }
    render() {
        return (<react_native_1.View style={styles.root}>
        <react_native_1.Text style={styles.greeting}>
          Hello{" "}
          {this.props.name +
            this.getExclamationMarks(this.state.intelligenceLevel)}
        </react_native_1.Text>

        <react_native_1.View style={styles.buttons}>
          <react_native_1.View style={styles.button}>
            <react_native_1.Button title="-" onPress={this.onDecrement} accessibilityLabel="decrement" color="red"/>
          </react_native_1.View>

          <react_native_1.View style={styles.button}>
            <react_native_1.Button title="+" onPress={this.onIncrement} accessibilityLabel="increment" color="blue"/>
          </react_native_1.View>
        </react_native_1.View>
      </react_native_1.View>);
    }
}
exports.Hello = Hello;
// styles
const styles = react_native_1.StyleSheet.create({
    root: {
        alignItems: "center",
        alignSelf: "center",
    },
    buttons: {
        flexDirection: "row",
        minHeight: 70,
        alignItems: "stretch",
        alignSelf: "center",
        borderWidth: 5,
    },
    button: {
        flex: 1,
        paddingVertical: 0,
    },
    greeting: {
        color: "#999",
        fontWeight: "bold",
    },
});
//# sourceMappingURL=Hello.js.map